import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { csv, arc, pie, timer } from 'd3';

const csvUrl =
  'https://gist.githubusercontent.com/curran/b236990081a24761f7000567094914e0/raw/acd2b8cecfe51c520622fbaf407ee88b8796bfc6/cssNamedColors.csv';

const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2 - 60;
const moveAbs = 135;
const circleRadius = 110 - 20;
const thickness = 10 - 4;

const myPieArc = (index, thickness) => {
  //console.log(arguments.length);
  //args.reduce(index, thickness, d);
  console.log(typeof arguments[2]);
//   console.log(arguments[0],arguments[2]);
  // const index = args[0];
  // const thickness = args[1];
//  const d = args[0];
  const innerR = circleRadius + thickness * (index - 1) * 2;
  const outerR = innerR + thickness;
//  console.log(innerR, outerR);
  return arc()
  .innerRadius(innerR)
  .outerRadius(outerR);
};

const App = () => {
  const [data, setData] = useState(null);

  useEffect(() => {
    d3.csv(csvUrl).then(setData);
  }, []);
  
  const [rotation, setRotation] = useState(0);
  useEffect(() => {
    const rotateTimer = timer(time => setRotation(time * 0.01));
    return () => rotateTimer.stop();
  }, []);

  if (!data) {
    return <pre>Loading...</pre>;
  }

  const colorPie = pie().value(2);
	const MyRingComponent = ({ index, rotateFactor, moveX, moveY }) => (
      <g transform={`translate(${centerX + moveX}, ${centerY + moveY}) rotate(${rotation*rotateFactor})`}>
        {colorPie(data).map(d => (
          <path fill={d.data['RGB hex value']} d={myPieArc(index,thickness)(d)} />
        ))}
      </g>
  );
  
  return (
    <svg width={width} height={height}>
			<MyRingComponent index="1" rotateFactor="1" moveX ={0} moveY ={0} />
      <MyRingComponent index="2" rotateFactor="-1" moveX ={0} moveY ={0} />
      <MyRingComponent index="3" rotateFactor={2} moveX ={0} moveY ={0} />
      <MyRingComponent index="4" rotateFactor={-2} moveX ={0} moveY ={0} />
      <MyRingComponent index="1" rotateFactor="1" moveX ={-moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="2" rotateFactor="-2" moveX ={-moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="3" rotateFactor="1" moveX ={-moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="4" rotateFactor="-2" moveX ={-moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="1" rotateFactor="1" moveX ={moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="2" rotateFactor="-2" moveX ={moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="3" rotateFactor="1" moveX ={moveAbs} moveY ={moveAbs} />
      <MyRingComponent index="4" rotateFactor="-2" moveX ={moveAbs} moveY ={moveAbs} />
    </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
